// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_BEHAVIOUR_PATH_H
#define _CLUTTERMM_BEHAVIOUR_PATH_H


#ifndef CLUTTERMM_DISABLE_DEPRECATED


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>


/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/behaviour.h>
#include <cluttermm/scriptable.h>
#include <cluttermm/alpha.h>
#include <cluttermm/path.h>
#include <cluttermm/types.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterBehaviourPath ClutterBehaviourPath;
typedef struct _ClutterBehaviourPathClass ClutterBehaviourPathClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class BehaviourPath_Class; } // namespace Clutter
namespace Clutter
{

/**
 * @deprecated Use Path and PathConstraint with Actor::animate() instead.
 */

class BehaviourPath
: public Behaviour,
  public Scriptable
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef BehaviourPath CppObjectType;
  typedef BehaviourPath_Class CppClassType;
  typedef ClutterBehaviourPath BaseObjectType;
  typedef ClutterBehaviourPathClass BaseClassType;

private:  friend class BehaviourPath_Class;
  static CppClassType behaviourpath_class_;

private:
  // noncopyable
  BehaviourPath(const BehaviourPath&);
  BehaviourPath& operator=(const BehaviourPath&);

protected:
  explicit BehaviourPath(const Glib::ConstructParams& construct_params);
  explicit BehaviourPath(ClutterBehaviourPath* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~BehaviourPath();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterBehaviourPath*       gobj()       { return reinterpret_cast<ClutterBehaviourPath*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterBehaviourPath* gobj() const { return reinterpret_cast<ClutterBehaviourPath*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterBehaviourPath* gobj_copy();

private:

  
protected:
    explicit BehaviourPath(const Glib::RefPtr<Alpha>& alpha, const Glib::RefPtr<Path>& path);


public:
  
  static Glib::RefPtr<BehaviourPath> create(const Glib::RefPtr<Alpha>& alpha, const Glib::RefPtr<Path>& path);

  
  static Glib::RefPtr<BehaviourPath> create_with_knots(const Glib::RefPtr<Alpha>& alpha,
                                                       const std::vector<Knot>& knots);
  static Glib::RefPtr<BehaviourPath> create_with_description(const Glib::RefPtr<Alpha>& alpha,
                                                             const Glib::ustring& description);

  
  /** Change the path that the actors will follow. This will take the
   * floating reference on the Clutter::Path so you do not need to unref
   * it.
   * 
   * @newin{1,0}
   * 
   * Deprecated: 1.6
   * @param path The new path to follow.
   */
  void set_path(const Glib::RefPtr<Path>& path);
  
  /** Get the current path of the behaviour
   * 
   * @newin{1,0}
   * 
   * Deprecated: 1.6
   * @return The path.
   */
  Glib::RefPtr<Path> get_path();
  
  /** Get the current path of the behaviour
   * 
   * @newin{1,0}
   * 
   * Deprecated: 1.6
   * @return The path.
   */
  Glib::RefPtr<const Path> get_path() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The ClutterPath object representing the path to animate along.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Path> > property_path() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The ClutterPath object representing the path to animate along.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Path> > property_path() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /**
   * @par Slot Prototype:
   * <tt>void on_my_%knot_reached(guint knot_num)</tt>
   *
   * This signal is emitted each time a node defined inside the path
   * is reached.
   * 
   * @newin{0,2}
   * 
   * Deprecated: 1.6
   * @param knot_num The index of the Clutter::Knot reached.
   */

  Glib::SignalProxy1< void,guint > signal_knot_reached();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  /// This is a default handler for the signal signal_knot_reached().
  virtual void on_knot_reached(guint knot_num);


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::BehaviourPath
   */
  Glib::RefPtr<Clutter::BehaviourPath> wrap(ClutterBehaviourPath* object, bool take_copy = false);
}


#endif // CLUTTERMM_DISABLE_DEPRECATED


#endif /* _CLUTTERMM_BEHAVIOUR_PATH_H */

