// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_BEHAVIOUR_SCALE_H
#define _CLUTTERMM_BEHAVIOUR_SCALE_H


#ifndef CLUTTERMM_DISABLE_DEPRECATED


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/behaviour.h>
#include <cluttermm/alpha.h>
#include <cluttermm/types.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterBehaviourScale ClutterBehaviourScale;
typedef struct _ClutterBehaviourScaleClass ClutterBehaviourScaleClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class BehaviourScale_Class; } // namespace Clutter
namespace Clutter
{

/**
 * @deprecated Use the Actor's scale-x and scale-y  properties, with Actor::animate(),
 * or Animator or State instead.
 */

class BehaviourScale : public Behaviour
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef BehaviourScale CppObjectType;
  typedef BehaviourScale_Class CppClassType;
  typedef ClutterBehaviourScale BaseObjectType;
  typedef ClutterBehaviourScaleClass BaseClassType;

private:  friend class BehaviourScale_Class;
  static CppClassType behaviourscale_class_;

private:
  // noncopyable
  BehaviourScale(const BehaviourScale&);
  BehaviourScale& operator=(const BehaviourScale&);

protected:
  explicit BehaviourScale(const Glib::ConstructParams& construct_params);
  explicit BehaviourScale(ClutterBehaviourScale* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~BehaviourScale();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterBehaviourScale*       gobj()       { return reinterpret_cast<ClutterBehaviourScale*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterBehaviourScale* gobj() const { return reinterpret_cast<ClutterBehaviourScale*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterBehaviourScale* gobj_copy();

private:

  
protected:
    explicit BehaviourScale(const Glib::RefPtr<Alpha>& alpha, double x_scale_start, double y_scale_start, double x_scale_end, double y_scale_end);


public:
  
  static Glib::RefPtr<BehaviourScale> create(const Glib::RefPtr<Alpha>& alpha, double x_scale_start, double y_scale_start, double x_scale_end, double y_scale_end);


  /** Sets the bounds used by scale behaviour.
   * 
   * @newin{0,6}
   * 
   * Deprecated: 1.6
   * @param x_scale_start Initial scale factor on the X axis.
   * @param y_scale_start Initial scale factor on the Y axis.
   * @param x_scale_end Final scale factor on the X axis.
   * @param y_scale_end Final scale factor on the Y axis.
   */
  void set_bounds(double x_scale_start, double y_scale_start, double x_scale_end, double y_scale_end);
  
  /** Retrieves the bounds used by scale behaviour.
   * 
   * @newin{0,4}
   * 
   * Deprecated: 1.6
   * @param x_scale_start Return location for the initial scale factor on the X
   * axis, or <tt>0</tt>.
   * @param y_scale_start Return location for the initial scale factor on the Y
   * axis, or <tt>0</tt>.
   * @param x_scale_end Return location for the final scale factor on the X axis,
   * or <tt>0</tt>.
   * @param y_scale_end Return location for the final scale factor on the Y axis,
   * or <tt>0</tt>.
   */
  void get_bounds(double& x_scale_start, double& y_scale_start, double& x_scale_end, double& y_scale_end) const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial scale on the X axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_x_scale_start() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial scale on the X axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_x_scale_start() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Final scale on the X axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_x_scale_end() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Final scale on the X axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_x_scale_end() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial scale on the Y axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_y_scale_start() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial scale on the Y axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_y_scale_start() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Final scale on the Y axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_y_scale_end() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Final scale on the Y axis.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_y_scale_end() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::BehaviourScale
   */
  Glib::RefPtr<Clutter::BehaviourScale> wrap(ClutterBehaviourScale* object, bool take_copy = false);
}


#endif // CLUTTERMM_DISABLE_DEPRECATED


#endif /* _CLUTTERMM_BEHAVIOUR_SCALE_H */

