// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_BOX_H
#define _CLUTTERMM_BOX_H


#ifndef CLUTTERMM_DISABLE_DEPRECATED


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2011 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/container.h>
#include <cluttermm/layout-manager.h>
#include <cluttermm/color.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterBox ClutterBox;
typedef struct _ClutterBoxClass ClutterBoxClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Box_Class; } // namespace Clutter
namespace Clutter
{

/**
 * @deprecated Use Actor instead.
 */

class Box :
    public Actor,
    public Container
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Box CppObjectType;
  typedef Box_Class CppClassType;
  typedef ClutterBox BaseObjectType;
  typedef ClutterBoxClass BaseClassType;

private:  friend class Box_Class;
  static CppClassType box_class_;

private:
  // noncopyable
  Box(const Box&);
  Box& operator=(const Box&);

protected:
  explicit Box(const Glib::ConstructParams& construct_params);
  explicit Box(ClutterBox* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Box();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterBox*       gobj()       { return reinterpret_cast<ClutterBox*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterBox* gobj() const { return reinterpret_cast<ClutterBox*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterBox* gobj_copy();

private:

  
protected:
  Box();
    explicit Box(const Glib::RefPtr<LayoutManager>& layoutManager);


public:
  
  static Glib::RefPtr<Box> create();

  
  static Glib::RefPtr<Box> create(const Glib::RefPtr<LayoutManager>& layoutManager);


  /** Retrieves the Clutter::LayoutManager instance used by @a box
   * 
   * @newin{1,2}
   * 
   * Deprecated: 1.10: Use Clutter::Actor::get_layout_manager() instead.
   * @return A Clutter::LayoutManager. The returned
   * Clutter::LayoutManager is owned by the Clutter::Box and it should not
   * be unreferenced.
   */
  Glib::RefPtr<LayoutManager> get_layout_manager();
  
  /** Retrieves the Clutter::LayoutManager instance used by @a box
   * 
   * @newin{1,2}
   * 
   * Deprecated: 1.10: Use Clutter::Actor::get_layout_manager() instead.
   * @return A Clutter::LayoutManager. The returned
   * Clutter::LayoutManager is owned by the Clutter::Box and it should not
   * be unreferenced.
   */
  Glib::RefPtr<const LayoutManager> get_layout_manager() const;

   //deprecated

  
  /** Sets (or unsets) the background color for @a box
   * 
   * @newin{1,2}
   * 
   * Deprecated: 1.10: Use Clutter::Actor::set_background_color() instead.
   * @param color The background color, or <tt>0</tt> to unset.
   */
  void set_color(const Color& color);

  
  /** Retrieves the background color of @a box
   * 
   * If the Clutter::Box::property_color_set() property is set to <tt>false</tt> the
   * returned Clutter::Color is undefined
   * 
   * @newin{1,2}
   * 
   * Deprecated: 1.10: Use Clutter::Actor::get_background_color() instead.
   * @param color Return location for a Clutter::Color.
   */

  Color get_color() const;

  
  // TODO: Documentation
  // FIXME: The std::map with a Glib::ValueBase does not work.
  // void pack(const Glib::RefPtr<Actor>& actor, const std::map<std::string, Glib::ValueBase>& properties);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The background color of the box.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Color > property_color() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The background color of the box.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Color > property_color() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether the background color is set.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_color_set() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether the background color is set.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_color_set() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Box
   */
  Glib::RefPtr<Clutter::Box> wrap(ClutterBox* object, bool take_copy = false);
}


#endif // CLUTTERMM_DISABLE_DEPRECATED


#endif /* _CLUTTERMM_BOX_H */

