// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_CLONE_H
#define _CLUTTERMM_CLONE_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2007-2009 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/actor.h>
#include <cluttermm/container.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterClone ClutterClone;
typedef struct _ClutterCloneClass ClutterCloneClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Clone_Class; } // namespace Clutter
namespace Clutter
{


class Clone :
  public Actor,
  public Container
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Clone CppObjectType;
  typedef Clone_Class CppClassType;
  typedef ClutterClone BaseObjectType;
  typedef ClutterCloneClass BaseClassType;

private:  friend class Clone_Class;
  static CppClassType clone_class_;

private:
  // noncopyable
  Clone(const Clone&);
  Clone& operator=(const Clone&);

protected:
  explicit Clone(const Glib::ConstructParams& construct_params);
  explicit Clone(ClutterClone* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Clone();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterClone*       gobj()       { return reinterpret_cast<ClutterClone*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterClone* gobj() const { return reinterpret_cast<ClutterClone*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterClone* gobj_copy();

private:

  
  //TODO: _IMPLEMENTS_INTERFACE(Atk::Implementor)
protected:
    explicit Clone(const Glib::RefPtr<Actor>& source);


public:

  
  static Glib::RefPtr<Clone> create(const Glib::RefPtr<Actor>& source);


  /** Retrieves the source Clutter::Actor being cloned by @a self.
   * 
   * @newin{1,0}
   * @return The actor source for the clone.
   */
  Glib::RefPtr<Actor> get_source();
  
  /** Retrieves the source Clutter::Actor being cloned by @a self.
   * 
   * @newin{1,0}
   * @return The actor source for the clone.
   */
  Glib::RefPtr<const Actor> get_source() const;
  
  /** Sets @a source as the source actor to be cloned by @a self.
   * 
   * @newin{1,0}
   * @param source A Clutter::Actor, or <tt>0</tt>.
   */
  void get_source(const Glib::RefPtr<Actor>& source);

  
  /** Sets @a source as the source actor to be cloned by @a self.
   * 
   * @newin{1,0}
   * @param source A Clutter::Actor, or <tt>0</tt>.
   */
  void set_source(const Glib::RefPtr<Actor>& source);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Specifies the actor to be cloned.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Actor > property_source() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Specifies the actor to be cloned.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Actor > property_source() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter

//vim: ts=2,sw=2


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Clone
   */
  Glib::RefPtr<Clutter::Clone> wrap(ClutterClone* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_CLONE_H */

