// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_COLORIZE_EFFECT_H
#define _CLUTTERMM_COLORIZE_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2011 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/offscreen-effect.h>
#include <cluttermm/color.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterColorizeEffect ClutterColorizeEffect;
typedef struct _ClutterColorizeEffectClass ClutterColorizeEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class ColorizeEffect_Class; } // namespace Clutter
namespace Clutter
{

class ColorizeEffect : public Clutter::OffscreenEffect
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef ColorizeEffect CppObjectType;
  typedef ColorizeEffect_Class CppClassType;
  typedef ClutterColorizeEffect BaseObjectType;
  typedef ClutterColorizeEffectClass BaseClassType;

private:  friend class ColorizeEffect_Class;
  static CppClassType colorizeeffect_class_;

private:
  // noncopyable
  ColorizeEffect(const ColorizeEffect&);
  ColorizeEffect& operator=(const ColorizeEffect&);

protected:
  explicit ColorizeEffect(const Glib::ConstructParams& construct_params);
  explicit ColorizeEffect(ClutterColorizeEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~ColorizeEffect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterColorizeEffect*       gobj()       { return reinterpret_cast<ClutterColorizeEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterColorizeEffect* gobj() const { return reinterpret_cast<ClutterColorizeEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterColorizeEffect* gobj_copy();

private:

  
protected:
    explicit ColorizeEffect(const Color& tint);


public:

  
  static Glib::RefPtr<ColorizeEffect> create(const Color& tint);


  /** Sets the tint to be used when colorizing
   * 
   * @newin{1,4}
   * @param tint The color to be used.
   */
  void set_tint(const Color& tint);

  
  /** Retrieves the tint used by @a effect
   * 
   * @newin{1,4}
   * @param tint Return location for the color used.
   */

  Color get_tint() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The tint to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Color > property_tint() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The tint to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Color > property_tint() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}//namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::ColorizeEffect
   */
  Glib::RefPtr<Clutter::ColorizeEffect> wrap(ClutterColorizeEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_COLORIZE_EFFECT_H */

