// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_CONSTRAINT_H
#define _CLUTTERMM_CONSTRAINT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2014 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <cluttermm/actor-meta.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterConstraint ClutterConstraint;
typedef struct _ClutterConstraintClass ClutterConstraintClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Constraint_Class; } // namespace Clutter
namespace Clutter
{
class Actor;

// TODO: fill this out once the examples are built.
/**
 * Constraint is a base abstract class for modifiers of an Actor position or size.
 *
 * A Constraint sub-class should contain the logic for modifying the position or
 * size of the Actor to which it is applied, by updating the actor's
 * allocation. Each Constraint can change the allocation of the actor to which
 * they are applied by overriding the Constraint::update_allocation_vfunc() virtual
 * function.
 *
 * @newin{1,4}
 */

class Constraint : public Clutter::ActorMeta
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Constraint CppObjectType;
  typedef Constraint_Class CppClassType;
  typedef ClutterConstraint BaseObjectType;
  typedef ClutterConstraintClass BaseClassType;

private:  friend class Constraint_Class;
  static CppClassType constraint_class_;

private:
  // noncopyable
  Constraint(const Constraint&);
  Constraint& operator=(const Constraint&);

protected:
  explicit Constraint(const Glib::ConstructParams& construct_params);
  explicit Constraint(ClutterConstraint* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Constraint();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterConstraint*       gobj()       { return reinterpret_cast<ClutterConstraint*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterConstraint* gobj() const { return reinterpret_cast<ClutterConstraint*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterConstraint* gobj_copy();

private:

  
protected:
  Constraint();

public:
  //There is no create() because this is an abstract base class.
  //_WRAP_CREATE()

protected:
   //gtkmmproc error: update_allocation :  vfunc defs lookup failed


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Constraint
   */
  Glib::RefPtr<Clutter::Constraint> wrap(ClutterConstraint* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_CONSTRAINT_H */

