// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_DEFORM_EFFECT_H
#define _CLUTTERMM_DEFORM_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2011 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/offscreen-effect.h>
#include <cogl/cogl.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterDeformEffect ClutterDeformEffect;
typedef struct _ClutterDeformEffectClass ClutterDeformEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class DeformEffect_Class; } // namespace Clutter
namespace Clutter
{

class DeformEffect :
  public Clutter::OffscreenEffect
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DeformEffect CppObjectType;
  typedef DeformEffect_Class CppClassType;
  typedef ClutterDeformEffect BaseObjectType;
  typedef ClutterDeformEffectClass BaseClassType;

private:  friend class DeformEffect_Class;
  static CppClassType deformeffect_class_;

private:
  // noncopyable
  DeformEffect(const DeformEffect&);
  DeformEffect& operator=(const DeformEffect&);

protected:
  explicit DeformEffect(const Glib::ConstructParams& construct_params);
  explicit DeformEffect(ClutterDeformEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DeformEffect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterDeformEffect*       gobj()       { return reinterpret_cast<ClutterDeformEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterDeformEffect* gobj() const { return reinterpret_cast<ClutterDeformEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterDeformEffect* gobj_copy();

private:

protected:
  DeformEffect();

public:
  
  static Glib::RefPtr<DeformEffect> create();


  //TODO IM: Cant see anywhere the Cogl stuff is wrapped.
  
  /** Sets the material that should be used when drawing the back face
   * of the actor during a deformation
   * 
   * The Clutter::DeformEffect will take a reference on the material's
   * handle
   * 
   * @newin{1,4}
   * @param material A handle to a Cogl material.
   */
  void set_back_material(CoglHandle material);

  //TODO: Wrap Cogl?
  
  /** Retrieves the handle to the back face material used by @a effect
   * 
   * @newin{1,4}
   * @return A handle for the material, or <tt>0</tt>.
   * The returned material is owned by the Clutter::DeformEffect and it
   * should not be freed directly.
   */
  CoglHandle get_back_material();

  
  /** Sets the number of horizontal and vertical tiles to be used
   * when applying the effect
   * 
   * More tiles allow a finer grained deformation at the expenses
   * of computation
   * 
   * @newin{1,4}
   * @param x_tiles Number of horizontal tiles.
   * @param y_tiles Number of vertical tiles.
   */
  void set_n_tiles(guint x_tiles, guint y_tiles);
  
  /** Retrieves the number of horizontal and vertical tiles used to sub-divide
   * the actor's geometry during the effect
   * 
   * @newin{1,4}
   * @param x_tiles Return location for the number of horizontal tiles,
   * or <tt>0</tt>.
   * @param y_tiles Return location for the number of vertical tiles,
   * or <tt>0</tt>.
   */
  void get_n_tiles(guint& x_tiles, guint& y_tiles) const;

  
  /** Invalidates the @a effect<!-- -->'s vertices and, if it is associated
   * to an actor, it will queue a redraw
   * 
   * @newin{1,4}
   */
  void invalidate();

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The material to be used when painting the back of the actor.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< CoglHandle* > property_back_material() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The material to be used when painting the back of the actor.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< CoglHandle* > property_back_material() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The number of horizontal tiles.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< guint > property_x_tiles() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The number of horizontal tiles.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< guint > property_x_tiles() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The number of vertical tiles.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< guint > property_y_tiles() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The number of vertical tiles.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< guint > property_y_tiles() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


protected:
   //gtkmmproc error: deform_vertex :  vfunc defs lookup failed


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};
}//namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::DeformEffect
   */
  Glib::RefPtr<Clutter::DeformEffect> wrap(ClutterDeformEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_DEFORM_EFFECT_H */

