// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_DESATURATE_EFFECT_H
#define _CLUTTERMM_DESATURATE_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2011 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/offscreen-effect.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterDesaturateEffect ClutterDesaturateEffect;
typedef struct _ClutterDesaturateEffectClass ClutterDesaturateEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class DesaturateEffect_Class; } // namespace Clutter
namespace Clutter
{


class DesaturateEffect : public OffscreenEffect
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DesaturateEffect CppObjectType;
  typedef DesaturateEffect_Class CppClassType;
  typedef ClutterDesaturateEffect BaseObjectType;
  typedef ClutterDesaturateEffectClass BaseClassType;

private:  friend class DesaturateEffect_Class;
  static CppClassType desaturateeffect_class_;

private:
  // noncopyable
  DesaturateEffect(const DesaturateEffect&);
  DesaturateEffect& operator=(const DesaturateEffect&);

protected:
  explicit DesaturateEffect(const Glib::ConstructParams& construct_params);
  explicit DesaturateEffect(ClutterDesaturateEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DesaturateEffect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterDesaturateEffect*       gobj()       { return reinterpret_cast<ClutterDesaturateEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterDesaturateEffect* gobj() const { return reinterpret_cast<ClutterDesaturateEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterDesaturateEffect* gobj_copy();

private:


protected:
    explicit DesaturateEffect(double factor);


public:
  
  static Glib::RefPtr<DesaturateEffect> create(double factor);

  
  /** Sets the desaturation factor for @a effect, with 0.0 being "do not desaturate"
   * and 1.0 being "fully desaturate"
   * 
   * @newin{1,4}
   * @param factor The desaturation factor, between 0.0 and 1.0.
   */
  void set_factor(double factor);

  
  /** Retrieves the desaturation factor of @a effect
   * 
   * @newin{1,4}
   * @return The desaturation factor.
   */
  double get_factor() const;

protected:
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The desaturation factor.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_factor() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The desaturation factor.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_factor() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}//namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::DesaturateEffect
   */
  Glib::RefPtr<Clutter::DesaturateEffect> wrap(ClutterDesaturateEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_DESATURATE_EFFECT_H */

