// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_EFFECT_H
#define _CLUTTERMM_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2010 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <cluttermm/actor-meta.h>


// TODO IM: added in 1.4 ???

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterEffect ClutterEffect;
typedef struct _ClutterEffectClass ClutterEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Effect_Class; } // namespace Clutter
namespace Clutter
{

//TODO IM: wrap this class and enable the vfunc.
// class PaintVolume;
//_WRAP_ENUM(EffectPaintFlags, ClutterEffectPaintFlags)

//TODO: Write a version of the large description from here: http://clutter-project.org/docs/clutter/stable/ClutterEffect.html#ClutterEffect.description

class Effect : public ActorMeta
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Effect CppObjectType;
  typedef Effect_Class CppClassType;
  typedef ClutterEffect BaseObjectType;
  typedef ClutterEffectClass BaseClassType;

private:  friend class Effect_Class;
  static CppClassType effect_class_;

private:
  // noncopyable
  Effect(const Effect&);
  Effect& operator=(const Effect&);

protected:
  explicit Effect(const Glib::ConstructParams& construct_params);
  explicit Effect(ClutterEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Effect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterEffect*       gobj()       { return reinterpret_cast<ClutterEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterEffect* gobj() const { return reinterpret_cast<ClutterEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterEffect* gobj_copy();

private:

  
protected:
  Effect();

public:
  //There is no create() because this is an abstract base class.
  //_WRAP_CREATE()

  
  /** Queues a repaint of the effect. The effect can detect when the ‘paint’
   * method is called as a result of this function because it will not
   * have the Clutter::EFFECT_PAINT_ACTOR_DIRTY flag set. In that case the
   * effect is free to assume that the actor has not changed its
   * appearance since the last time it was painted so it doesn't need to
   * call Clutter::Actor::continue_paint() if it can draw a cached
   * image. This is mostly intended for effects that are using a
   * Cogl::Offscreen to redirect the actor (such as
   * Clutter::OffscreenEffect). In that case the effect can save a bit of
   * rendering time by painting the cached texture without causing the
   * entire actor to be painted.
   * 
   * This function can be used by effects that have their own animatable
   * parameters. For example, an effect which adds a varying degree of a
   * red tint to an actor by redirecting it through a CoglOffscreen
   * might have a property to specify the level of tint. When this value
   * changes, the underlying actor doesn't need to be redrawn so the
   * effect can call queue_repaint() to make sure the
   * effect is repainted.
   * 
   * Note however that modifying the position of the parent of an actor
   * may change the appearance of the actor because its transformation
   * matrix would change. In this case a redraw wouldn't be queued on
   * the actor itself so the Clutter::EFFECT_PAINT_ACTOR_DIRTY would still
   * not be set. The effect can detect this case by keeping track of the
   * last modelview matrix that was used to render the actor and
   * veryifying that it remains the same in the next paint.
   * 
   * Any other effects that are layered on top of the passed in effect
   * will still be passed the Clutter::EFFECT_PAINT_ACTOR_DIRTY flag. If
   * anything queues a redraw on the actor without specifying an effect
   * or with an effect that is lower in the chain of effects than this
   * one then that will override this call. In that case this effect
   * will instead be called with the Clutter::EFFECT_PAINT_ACTOR_DIRTY
   * flag set.
   * 
   * @newin{1,8}
   */
  void queue_repaint();

protected:
   //TODO: Signals, properties, vfuncs
  //gtkmmproc error: paint :  vfunc defs lookup failed
  //gtkmmproc error: pick :  vfunc defs lookup failed
  //gtkmmproc error: pre_paint :  vfunc defs lookup failed
  //gtkmmproc error: post_paint :  vfunc defs lookup failed

  //gtkmmproc error: get_paint_volume :  vfunc defs lookup failed


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Effect
   */
  Glib::RefPtr<Clutter::Effect> wrap(ClutterEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_EFFECT_H */

