// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_MODEL_ITER_H
#define _CLUTTERMM_MODEL_ITER_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2014 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterModelIter ClutterModelIter;
typedef struct _ClutterModelIterClass ClutterModelIterClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class ModelIter_Class; } // namespace Clutter
namespace Clutter
{

class Model;


class ModelIter: public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef ModelIter CppObjectType;
  typedef ModelIter_Class CppClassType;
  typedef ClutterModelIter BaseObjectType;
  typedef ClutterModelIterClass BaseClassType;

private:  friend class ModelIter_Class;
  static CppClassType modeliter_class_;

private:
  // noncopyable
  ModelIter(const ModelIter&);
  ModelIter& operator=(const ModelIter&);

protected:
  explicit ModelIter(const Glib::ConstructParams& construct_params);
  explicit ModelIter(ClutterModelIter* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~ModelIter();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterModelIter*       gobj()       { return reinterpret_cast<ClutterModelIter*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterModelIter* gobj() const { return reinterpret_cast<ClutterModelIter*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterModelIter* gobj_copy();

private:

  
protected:
  ModelIter();

public:
  //_WRAP_CREATE()
  //_WRAP_METHOD(void get_valist(va_list args), clutter_model_iter_get_valist)

  
  /** Sets an initializes @a value to that at @a column. When done with @a value, 
   * Glib::value_unset() needs to be called to free any allocated memory.
   * 
   * @newin{0,6}
   * @param column Column number to retrieve the value from.
   * @param value An empty Value to set.
   */
  void get_value(guint column, const Glib::ValueBase& value);
  
  /** See set(); this version takes a va_list for language
   * bindings.
   * 
   * @newin{0,6}
   * @param args Va_list of column/value pairs, terminiated by -1.
   */
  void set_valist(va_list args);
  
  /** Sets the data in the cell specified by @a iter and @a column. The type of
   *  @a value must be convertable to the type of the column.
   * 
   * @newin{0,6}
   * @param column Column number to retrieve the value from.
   * @param value New value for the cell.
   */
  void set_value(guint column, const Glib::ValueBase& value);
  
  /** Gets whether the current iterator is at the beginning of the model
   * to which it belongs.
   * 
   * @newin{0,6}
   * @return #<tt>true</tt> if @a iter is the first iter in the filtered model.
   */
  bool is_first() const;
  
  /** Gets whether the iterator is at the end of the model to which it
   * belongs.
   * 
   * @newin{0,6}
   * @return #<tt>true</tt> if @a iter is the last iter in the filtered model.
   */
  bool is_last() const;
  
  /** Updates the @a iter to point at the next position in the model.
   * The model implementation should take into account the presence of
   * a filter function.
   * 
   * @newin{0,6}
   * @return The passed iterator, updated to point at the next
   * row in the model.
   */
  Glib::RefPtr<ModelIter> next();
  
  /** Sets the @a iter to point at the previous position in the model.
   * The model implementation should take into account the presence of
   * a filter function.
   * 
   * @newin{0,6}
   * @return The passed iterator, updated to point at the previous
   * row in the model.
   */
  Glib::RefPtr<ModelIter> prev();
  
  /** Retrieves a pointer to the Clutter::Model that this iter is part of.
   * 
   * @newin{0,6}
   * @return A pointer to a Clutter::Model.
   */
  Glib::RefPtr<Model> get_model();
  
  /** Retrieves the position of the row that the @a iter points to.
   * 
   * @newin{0,6}
   * @return The position of the @a iter in the model.
   */
  guint get_row() const;

   //gtkmmproc error: model : property defs lookup failed.
   //gtkmmproc error: row : property defs lookup failed.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::ModelIter
   */
  Glib::RefPtr<Clutter::ModelIter> wrap(ClutterModelIter* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_MODEL_ITER_H */

