// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_MODEL_H
#define _CLUTTERMM_MODEL_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2014 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <cluttermm/model-iter.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterModel ClutterModel;
typedef struct _ClutterModelClass ClutterModelClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Model_Class; } // namespace Clutter
namespace Clutter
{

//TODO: Write a version of the large description from here: http://clutter-project.org/docs/clutter/stable/ClutterModel.html#ClutterModel.description

class Model : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Model CppObjectType;
  typedef Model_Class CppClassType;
  typedef ClutterModel BaseObjectType;
  typedef ClutterModelClass BaseClassType;

private:  friend class Model_Class;
  static CppClassType model_class_;

private:
  // noncopyable
  Model(const Model&);
  Model& operator=(const Model&);

protected:
  explicit Model(const Glib::ConstructParams& construct_params);
  explicit Model(ClutterModel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Model();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterModel*       gobj()       { return reinterpret_cast<ClutterModel*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterModel* gobj() const { return reinterpret_cast<ClutterModel*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterModel* gobj_copy();

private:


protected:
  Model();

public:
  //There is no create() because this is an abstract base class.
  //_WRAP_CREATE()

  //_WRAP_METHOD(GType get_type(), clutter_model_get_type)
  //TODO: _WRAP_METHOD(void set_types(guint n_columns, GType* types), clutter_model_set_types)

  
  // TODO IM: Template these to get rid of the GValues:

  //TODO: Value is a templated type and the n_columns parameter is superfluous:
  //_WRAP_METHOD(void append(int n_columns, const std::vector<int>& columns, const std::vector<Glib::Value>& values), clutter_model_appendv)
  //_WRAP_METHOD(void prepend(int n_columns, const std::vector<int>&  columns, std::vector<Glib::Value>  values), clutter_model_prependv)
  //_WRAP_METHOD(void insert(int row, int n_columns, const std::vector<int>&  columns, const std::vector<GLib::Value>& values), clutter_model_insertv)

  //TODO: Rename ths to insert_value() and add a templated insert()?
  
  /** Sets the data in the cell specified by @a iter and @a column. The type of 
   *  @a value must be convertable to the type of the column. If the row does
   * not exist then it is created.
   * 
   * @newin{0,6}
   * @param row Position of the row to modify.
   * @param column Column to modify.
   * @param value New value for the cell.
   */
  void insert(guint row, guint column, const Glib::ValueBase& value);

  
  /** Removes the row at the given position from the model.
   * 
   * @newin{0,6}
   * @param row Position of row to remove.
   */
  void remove(guint row);
  
  /** Retrieves the number of rows inside @a model, eventually taking
   * into account any filtering function set using set_filter().
   * 
   * @newin{0,6}
   * @return The length of the @a model. If there is a filter set, then
   * the length of the filtered @a model is returned.
   */
  guint get_n_rows() const;
  
  /** Retrieves the number of columns inside @a model.
   * 
   * @newin{0,6}
   * @return The number of columns.
   */
  guint get_n_columns() const;
  
  /** Retrieves the name of the @a column
   * 
   * @newin{0,6}
   * @param column The column number.
   * @return The name of the column. The model holds the returned
   * string, and it should not be modified or freed.
   */
  Glib::ustring get_column_name(guint column) const;
  
  /** Retrieves the type of the @a column.
   * 
   * @newin{0,6}
   * @param column The column number.
   * @return The type of the column.
   */
  GType get_column_type(guint column) const;
  //~ _WRAP_METHOD(Glib::RefPtr<ModelIter> get_first_iter(), clutter_model_get_first_iter )
  //~ _WRAP_METHOD(Glib::RefPtr<ModelIter> get_last_iter(), clutter_model_get_last_iter )
  //~ _WRAP_METHOD(Glib::RefPtr<ModelIter> get_iter_at_row(guint row), clutter_model_get_iter_at_row )


  /**
   * @par Slot Prototype:
   * <tt>void on_my_%row_added(const Glib::RefPtr<ModelIter>& iter)</tt>
   *
   * The signal_row_added() signal is emitted when a new row has been added.
   * The data on the row has already been set when the signal_row_added() signal
   * has been emitted.
   * 
   * @newin{0,6}
   * @param iter A Clutter::ModelIter pointing to the new row.
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<ModelIter>& > signal_row_added();

  
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%row_removed(const Glib::RefPtr<ModelIter>& iter)</tt>
   *
   * The signal_row_removed() signal is emitted when a row has been removed.
   * The data on the row pointed by the passed iterator is still valid
   * when the signal_row_removed() signal has been emitted.
   * 
   * @newin{0,6}
   * @param iter A Clutter::ModelIter pointing to the removed row.
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<ModelIter>& > signal_row_removed();

  
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%row_changed(const Glib::RefPtr<ModelIter>& iter)</tt>
   *
   * The signal_row_removed() signal is emitted when a row has been changed.
   * The data on the row has already been updated when the signal_row_changed()
   * signal has been emitted.
   * 
   * @newin{0,6}
   * @param iter A Clutter::ModelIter pointing to the changed row.
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<ModelIter>& > signal_row_changed();


  /**
   * @par Slot Prototype:
   * <tt>void on_my_%sort_changed()</tt>
   *
   * The signal_sort_changed() signal is emitted after the model has been sorted
   * 
   * @newin{0,6}
   */

  Glib::SignalProxy0< void > signal_sort_changed();

  
  /**
   * @par Slot Prototype:
   * <tt>void on_my_%filter_changed()</tt>
   *
   * The signal_filter_changed() signal is emitted when a new filter has been applied
   * 
   * @newin{0,6}
   */

  Glib::SignalProxy0< void > signal_filter_changed();


  //gtkmmproc error: get_n_rows :  vfunc defs lookup failed
  //gtkmmproc error: get_n_columns :  vfunc defs lookup failed
  //gtkmmproc error: get_column_name :  vfunc defs lookup failed
  //gtkmmproc error: get_column_type :  vfunc defs lookup failed
  //gtkmmproc error: insert_row :  vfunc defs lookup failed
  //gtkmmproc error: remove_row :  vfunc defs lookup failed
  //gtkmmproc error: get_iter_at_row :  vfunc defs lookup failed
  //TODO? _WRAP_VFUNC(void resort(ClutterModelSortFunc func, Glib::Pointer data), resort)


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  /// This is a default handler for the signal signal_row_added().
  virtual void on_row_added(const Glib::RefPtr<ModelIter>& iter);
  /// This is a default handler for the signal signal_row_removed().
  virtual void on_row_removed(const Glib::RefPtr<ModelIter>& iter);
  /// This is a default handler for the signal signal_row_changed().
  virtual void on_row_changed(const Glib::RefPtr<ModelIter>& iter);
  /// This is a default handler for the signal signal_sort_changed().
  virtual void on_sort_changed();
  /// This is a default handler for the signal signal_filter_changed().
  virtual void on_filter_changed();


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Model
   */
  Glib::RefPtr<Clutter::Model> wrap(ClutterModel* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_MODEL_H */

