// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_OFFSCREEN_EFFECT_H
#define _CLUTTERMM_OFFSCREEN_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2010 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/effect.h>
#include <cluttermm/types.h>

#include <cogl/cogl.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterOffscreenEffect ClutterOffscreenEffect;
typedef struct _ClutterOffscreenEffectClass ClutterOffscreenEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class OffscreenEffect_Class; } // namespace Clutter
namespace Clutter
{

class Rect;


class OffscreenEffect : public Effect
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef OffscreenEffect CppObjectType;
  typedef OffscreenEffect_Class CppClassType;
  typedef ClutterOffscreenEffect BaseObjectType;
  typedef ClutterOffscreenEffectClass BaseClassType;

private:  friend class OffscreenEffect_Class;
  static CppClassType offscreeneffect_class_;

private:
  // noncopyable
  OffscreenEffect(const OffscreenEffect&);
  OffscreenEffect& operator=(const OffscreenEffect&);

protected:
  explicit OffscreenEffect(const Glib::ConstructParams& construct_params);
  explicit OffscreenEffect(ClutterOffscreenEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~OffscreenEffect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterOffscreenEffect*       gobj()       { return reinterpret_cast<ClutterOffscreenEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterOffscreenEffect* gobj() const { return reinterpret_cast<ClutterOffscreenEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterOffscreenEffect* gobj_copy();

private:


protected:
  OffscreenEffect();

public:
  //There is no create() because this is an abstract base class.
  //_WRAP_CREATE()


  // TODO IM: this is likely to be deprecated, as CoglMaterial is
  // deprecated for CoglPipeline.
  //_WRAP_METHOD(CoglMaterial* get_target(), clutter_offscreen_effect_get_target)

  
  /** Retrieves the texture used as a render target for the offscreen
   * buffer created by @a effect
   * 
   * You should only use the returned texture when painting. The texture
   * may change after ClutterEffect::pre_paint is called so the effect
   * implementation should update any references to the texture after
   * chaining-up to the parent's pre_paint implementation. This can be
   * used instead of get_target() when the
   * effect subclass wants to paint using its own material.
   * 
   * @newin{1,10}
   * @return A Cogl::Handle or Cogl::INVALID_HANDLE. The
   * returned texture is owned by Clutter and it should not be
   * modified or freed.
   */
  CoglHandle get_texture();
  
  /** Calls the create_texture() virtual function of the @a effect
   * 
   * @newin{1,4}
   * @param width The minimum width of the target texture.
   * @param height The minimum height of the target texture.
   * @return A handle to a Cogl texture, or
   * Cogl::INVALID_HANDLE. The returned handle has its reference
   * count increased.
   */
  CoglHandle create_texture(float width, float height);
  
  /** Calls the paint_target() virtual function of the @a effect
   * 
   * @newin{1,4}
   */
  void paint_target();

  //TODO: _WRAP_METHOD(bool get_target_rect(Rect& rect{>>}), clutter_offscreen_effect_get_target_rect)

protected:
  //TODO: Signals, properties, vfuncs
  //gtkmmproc error: create_texture :  vfunc defs lookup failed
  //gtkmmproc error: paint_target :  vfunc defs lookup failed


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::OffscreenEffect
   */
  Glib::RefPtr<Clutter::OffscreenEffect> wrap(ClutterOffscreenEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_OFFSCREEN_EFFECT_H */

