// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_PAGE_TURN_EFFECT_H
#define _CLUTTERMM_PAGE_TURN_EFFECT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2011 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/deform-effect.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterPageTurnEffect ClutterPageTurnEffect;
typedef struct _ClutterPageTurnEffectClass ClutterPageTurnEffectClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class PageTurnEffect_Class; } // namespace Clutter
namespace Clutter
{


class PageTurnEffect :  public Clutter::DeformEffect
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef PageTurnEffect CppObjectType;
  typedef PageTurnEffect_Class CppClassType;
  typedef ClutterPageTurnEffect BaseObjectType;
  typedef ClutterPageTurnEffectClass BaseClassType;

private:  friend class PageTurnEffect_Class;
  static CppClassType pageturneffect_class_;

private:
  // noncopyable
  PageTurnEffect(const PageTurnEffect&);
  PageTurnEffect& operator=(const PageTurnEffect&);

protected:
  explicit PageTurnEffect(const Glib::ConstructParams& construct_params);
  explicit PageTurnEffect(ClutterPageTurnEffect* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~PageTurnEffect();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterPageTurnEffect*       gobj()       { return reinterpret_cast<ClutterPageTurnEffect*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterPageTurnEffect* gobj() const { return reinterpret_cast<ClutterPageTurnEffect*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterPageTurnEffect* gobj_copy();

private:

protected:
    explicit PageTurnEffect(double period, double angle, float radius);


public:
  
  static Glib::RefPtr<PageTurnEffect> create(double period, double angle, float radius);


  /** Sets the period of the page curling, between 0.0 (no curling)
   * and 1.0 (fully curled)
   * 
   * @newin{1,4}
   * @param period The period of the page curl, between 0.0 and 1.0.
   */
  void set_period(double period);
  
  /** Retrieves the value set using get_period()
   * 
   * @newin{1,4}
   * @return The period of the page curling.
   */
  double get_period() const;
  
  /** Sets the angle of the page curling, in degrees
   * 
   * @newin{1,4}
   * @param angle The angle of the page curl, in degrees.
   */
  void set_angle(double angle);
  
  /** Retrieves the value set using get_angle()
   * 
   * @newin{1,4}
   * @return The angle of the page curling.
   */
  double get_angle() const;
  
  /** Sets the radius of the page curling
   * 
   * @newin{1,4}
   * @param radius The radius of the page curling, in pixels.
   */
  void set_radius(float radius);
  
  /** Retrieves the value set using set_radius()
   * 
   * @newin{1,4}
   * @return The radius of the page curling.
   */
  float get_radius() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The angle of the page rotation, in degrees.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_angle() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The angle of the page rotation, in degrees.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_angle() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The period of the page turn.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_period() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The period of the page turn.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_period() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The radius of the page curl.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< float > property_radius() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The radius of the page curl.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< float > property_radius() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

}//namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::PageTurnEffect
   */
  Glib::RefPtr<Clutter::PageTurnEffect> wrap(ClutterPageTurnEffect* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_PAGE_TURN_EFFECT_H */

