// -*- c++ -*-
// Generated by gmmproc 2.40.0 -- DO NOT MODIFY!
#ifndef _CLUTTERMM_RECTANGLE_H
#define _CLUTTERMM_RECTANGLE_H


#ifndef CLUTTERMM_DISABLE_DEPRECATED


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/actor.h>
#include <cluttermm/color.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterRectangle ClutterRectangle;
typedef struct _ClutterRectangleClass ClutterRectangleClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class Rectangle_Class; } // namespace Clutter
namespace Clutter
{

/**
 * @deprecated Use Actor instead.
 */

class Rectangle :
  public Actor
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Rectangle CppObjectType;
  typedef Rectangle_Class CppClassType;
  typedef ClutterRectangle BaseObjectType;
  typedef ClutterRectangleClass BaseClassType;

private:  friend class Rectangle_Class;
  static CppClassType rectangle_class_;

private:
  // noncopyable
  Rectangle(const Rectangle&);
  Rectangle& operator=(const Rectangle&);

protected:
  explicit Rectangle(const Glib::ConstructParams& construct_params);
  explicit Rectangle(ClutterRectangle* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Rectangle();

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterRectangle*       gobj()       { return reinterpret_cast<ClutterRectangle*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterRectangle* gobj() const { return reinterpret_cast<ClutterRectangle*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterRectangle* gobj_copy();

private:

  
protected:
  Rectangle();
    explicit Rectangle(const Color& color);


public:
  
  static Glib::RefPtr<Rectangle> create();

  
  static Glib::RefPtr<Rectangle> create(const Color& color);


  /** Retrieves the color of @a rectangle.
   * @param color Return location for a Clutter::Color.
   */

  Color get_color() const;
  
  /** Sets the color of @a rectangle.
   * @param color A Clutter::Color.
   */
  void set_color(const Color& color);

  
  /** Gets the color of the border used by @a rectangle and places
   * it into @a color.
   * 
   * @newin{0,2}
   * @param color Return location for a Clutter::Color.
   */

  Color get_border_color() const;
  
  /** Sets the color of the border used by @a rectangle using @a color
   * @param color The color of the border.
   */
  void set_border_color(const Color& color);

  
  /** Gets the width (in pixels) of the border used by @a rectangle
   * 
   * @newin{0,2}
   * @return The border's width.
   */
  guint get_border_width() const;
  
  /** Sets the width (in pixel) of the border used by @a rectangle.
   * A @a width of 0 will unset the border.
   * 
   * @newin{0,2}
   * @param width The width of the border.
   */
  void set_border_width(guint width);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The color of the border of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Color > property_border_color() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The color of the border of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Color > property_border_color() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The width of the border of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< guint > property_border_width() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The width of the border of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< guint > property_border_width() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The color of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Color > property_color() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The color of the rectangle.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Color > property_color() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether the rectangle should have a border.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_has_border() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether the rectangle should have a border.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_has_border() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Clutter

//vim: ts=2,sw=2


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::Rectangle
   */
  Glib::RefPtr<Clutter::Rectangle> wrap(ClutterRectangle* object, bool take_copy = false);
}


#endif // CLUTTERMM_DISABLE_DEPRECATED


#endif /* _CLUTTERMM_RECTANGLE_H */

